"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var node_polyglot_1 = __importDefault(require("node-polyglot"));
var enhanceT_1 = __importDefault(require("./enhanceT"));
var i18nContext_1 = __importDefault(require("./i18nContext"));
var I18n = function (_a) {
    var children = _a.children, locale = _a.locale, phrases = _a.phrases, allowMissing = _a.allowMissing, onMissingKey = _a.onMissingKey, interpolation = _a.interpolation;
    var polyglot = React.useMemo(
    // Create a new instance on every change
    // This make sure we always consume the latest phrases and Polyglot context
    function () {
        return new node_polyglot_1.default({
            locale: locale,
            phrases: phrases,
            allowMissing: allowMissing,
            onMissingKey: onMissingKey,
            interpolation: interpolation,
        });
    }, [locale, phrases, allowMissing, onMissingKey, interpolation]);
    var polyglotContext = React.useMemo(function () { return ({
        locale: polyglot.locale(),
        t: enhanceT_1.default(polyglot.t.bind(polyglot)),
    }); }, [polyglot]);
    return (React.createElement(i18nContext_1.default.Provider, { value: polyglotContext }, polyglotContext.locale && children));
};
exports.default = I18n;
